## location-service 3.0.0+16.04.20160405-0ubuntu1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(ubuntu-location-service)

# We haven't received version information via the packaging setup.
# For that, we try to determine sensible values on our own, ensuring
# plain old invocations to cmake still work as expected.
if (NOT DEFINED UBUNTU_LOCATION_SERVICE_VERSION_MAJOR)
  find_program(LSB_RELEASE lsb_release)
  execute_process(
    COMMAND ${LSB_RELEASE} -c -s
    OUTPUT_VARIABLE DISTRO_CODENAME
    OUTPUT_STRIP_TRAILING_WHITESPACE)

  # We explicitly ignore errors and only check if we are building for vivid.
  # For all other cases:
  #   - releases other than vivid
  #   - other distros
  #   - errors
  # we define the version to be 2.0.0
  if (${DISTRO_CODENAME} STREQUAL "vivid")
    set(UBUNTU_LOCATION_SERVICE_VERSION_MAJOR 2)
    set(UBUNTU_LOCATION_SERVICE_VERSION_MINOR 0)
    set(UBUNTU_LOCATION_SERVICE_VERSION_PATCH 0)
  else ()
    set(UBUNTU_LOCATION_SERVICE_VERSION_MAJOR 3)
    set(UBUNTU_LOCATION_SERVICE_VERSION_MINOR 0)
    set(UBUNTU_LOCATION_SERVICE_VERSION_PATCH 0)
  endif()
endif()

message(STATUS "${CMAKE_PROJECT_NAME} ${UBUNTU_LOCATION_SERVICE_VERSION_MAJOR}.${UBUNTU_LOCATION_SERVICE_VERSION_MINOR}.${UBUNTU_LOCATION_SERVICE_VERSION_PATCH}")

set(UBUNTU_LOCATION_SERVICE_TRUST_STORE_SERVICE_NAME "UbuntuLocationService")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -Wextra -fPIC")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall -fno-strict-aliasing -pedantic -Wextra -fPIC")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

include(cmake/EnableCoverageReport.cmake)
include(cmake/FindGFlags.cmake)
include(cmake/FindGLog.cmake)
include(cmake/PrePush.cmake)
include(CTest)

include(GNUInstallDirs)

find_package(PkgConfig)
find_package(Boost COMPONENTS filesystem system program_options)
find_package(GLog)
find_package(GFlags)
find_package(Threads)
pkg_check_modules(DBUS dbus-1 REQUIRED)
pkg_check_modules(DBUS_CPP dbus-cpp REQUIRED)
pkg_check_modules(JSON_C json-c REQUIRED)
pkg_check_modules(LIBAPPARMOR libapparmor REQUIRED)
pkg_check_modules(NET_CPP net-cpp REQUIRED)
pkg_check_modules(PROCESS_CPP process-cpp REQUIRED)
pkg_check_modules(PROPERTIES_CPP properties-cpp REQUIRED)
pkg_check_modules(TRUST_STORE trust-store REQUIRED)
pkg_check_modules(UBUNTU_PLATFORM_HARDWARE_API ubuntu-platform-hardware-api)
#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
IF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
ENDIF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])

option (DISABLE_ERROR_ON_LOCAL_TYPEDEFS_WARNINGS "Disable errors when local typedefs are unused" ON)
if (DISABLE_ERROR_ON_LOCAL_TYPEDEFS_WARNINGS)
    SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=unused-local-typedefs")
endif (DISABLE_ERROR_ON_LOCAL_TYPEDEFS_WARNINGS)

#
# Code style fixer. We rely on clang-format to adjust the formatting of source code.
#
find_program(CLANG_FORMAT_COMMAND NAMES clang-format-3.6 clang-format-3.5)
if (NOT CLANG_FORMAT_COMMAND)
  message(WARNING "Cannot find clang-format >= clang-format-3.5: formatcode target will not be available")
endif()

if (CLANG_FORMAT_COMMAND)
  file(GLOB_RECURSE UBUNTU_LOCATION_SERVICE_INTERFACE_HEADER_FILES ${CMAKE_SOURCE_DIR}/include/*.h)
  file(GLOB_RECURSE UBUNTU_LOCATION_SERVICE_IMPLEMENTATION_FILES ${CMAKE_SOURCE_DIR}/src/*.h ${CMAKE_SOURCE_DIR}/src/*.cpp)
  add_custom_target(formatcode ${CLANG_FORMAT_COMMAND} -i ${UBUNTU_LOCATION_SERVICE_INTERFACE_HEADER_FILES} ${UBUNTU_LOCATION_SERVICE_IMPLEMENTATION_FILES} SOURCES _clang-format)
endif()

include_directories(
  3rd-party/

  ${Boost_INCLUDE_DIRS}
  ${DBUS_INCLUDE_DIRS}
  ${DBUS_CPP_INCLUDE_DIRS}
  ${JSON_C_INCLUDE_DIRS}
  ${LIBAPPARMOR_INCLUDE_DIRS}
  ${NET_CPP_INCLUDE_DIRS}
  ${PROPERTIES_CPP_INCLUDE_DIRS}
  ${PROCESS_CPP_INCLUDE_DIRS}
  ${TRUST_STORE_INCLUDE_DIRS}
  ${GLog_INCLUDE_DIR}
  ${GFlags_INCLUDE_DIR}

  ${CMAKE_SOURCE_DIR}/include/location_service
  ${CMAKE_SOURCE_DIR}/src/location_service
  ${CMAKE_BINARY_DIR}/src/location_service
)

file(GLOB_RECURSE UBUNTU_LOCATION_SERVICE_PUBLIC_HEADERS ${CMAKE_CURRENT_SOURCE_DIR} *.h)

add_subdirectory(data)
add_subdirectory(doc)
add_subdirectory(examples)
add_subdirectory(include)
add_subdirectory(po)
add_subdirectory(src)
add_subdirectory(tests)

# There's no nice way to format this. Thanks CMake.
add_test(LGPL-required
  /bin/sh -c "! grep -rl 'GNU General' ${PROJECT_SOURCE_DIR}/src ${PROJECT_SOURCE_DIR}/include"
)

enable_coverage_report(service)

=== examples/CMakeLists.txt ===
add_subdirectory(service)

install(
  DIRECTORY standalone
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${CMAKE_PROJECT_NAME}/examples)

=== src/location_service/com/ubuntu/CMakeLists.txt ===
add_subdirectory(location)

=== src/location_service/com/ubuntu/location/CMakeLists.txt ===
if (UBUNTU_PLATFORM_HARDWARE_API_FOUND)
  add_definitions(-DCOM_UBUNTU_LOCATION_SERVICE_HAVE_UBUNTU_PLATFORM_HARDWARE_API)
endif()

if (NET_CPP_FOUND)
  add_definitions(-DCOM_UBUNTU_LOCATION_SERVICE_HAVE_NET_CPP=1)

  set(ICHNAEA_REPORTER_SRCS service/ichnaea_reporter.cpp)
endif()

add_subdirectory(providers)

configure_file(
  service/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/service/config.h @ONLY
)

include_directories(${UBUNTU_PLATFORM_HARDWARE_API_INCLUDE_DIRS})

add_library(
  ubuntu-location-service SHARED

  ${UBUNTU_LOCATION_SERVICE_PUBLIC_HEADERS}

  default_provider_selection_policy.cpp
  fusion_provider_selection_policy.cpp
  non_selecting_provider_selection_policy.cpp

  criteria.cpp
  engine.cpp
  fusion_provider.cpp
  init_and_shutdown.cpp
  position.cpp
  provider.cpp
  provider_factory.cpp
  proxy_provider.cpp
  satellite_based_positioning_state.cpp
  settings.cpp
  time_based_update_policy.cpp
  set_name_for_thread.cpp
  time_since_boot.cpp
  wifi_and_cell_reporting_state.cpp

  boost_ptree_settings.cpp

  service/default_configuration.cpp
  service/default_permission_manager.cpp
  service/harvester.cpp
  service/demultiplexing_reporter.h
  service/demultiplexing_reporter.cpp
  service/runtime.cpp
  service/runtime_tests.h
  service/runtime_tests.cpp
  service/trust_store_permission_manager.cpp

  service/implementation.cpp
  service/skeleton.cpp
  service/stub.cpp

  service/session/implementation.cpp
  service/session/interface.cpp
  service/session/skeleton.cpp
  service/session/stub.cpp

  providers/config.cpp

  providers/remote/provider.cpp
  providers/remote/skeleton.cpp
  providers/remote/stub.cpp

  ${ICHNAEA_REPORTER_SRCS}
)

add_library(
  ubuntu-location-service-connectivity SHARED

  set_name_for_thread.cpp

  connectivity/cached_radio_cell.cpp
  connectivity/cached_wireless_network.cpp
  connectivity/manager.cpp
  connectivity/radio_cell.cpp
  connectivity/wireless_network.cpp

  connectivity/ofono_nm_connectivity_manager.cpp
)

set(symbol_map "${CMAKE_SOURCE_DIR}/symbols.map")

set_target_properties(
  ubuntu-location-service

  PROPERTIES
  LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}"
  LINK_DEPENDS ${symbol_map}
  VERSION ${UBUNTU_LOCATION_SERVICE_VERSION_MAJOR}.${UBUNTU_LOCATION_SERVICE_VERSION_MINOR}.${UBUNTU_LOCATION_SERVICE_VERSION_PATCH}
  SOVERSION ${UBUNTU_LOCATION_SERVICE_VERSION_MAJOR}
)

set_target_properties(
  ubuntu-location-service-connectivity

  PROPERTIES
  LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}"
  LINK_DEPENDS ${symbol_map}
  VERSION ${UBUNTU_LOCATION_SERVICE_VERSION_MAJOR}.${UBUNTU_LOCATION_SERVICE_VERSION_MINOR}.${UBUNTU_LOCATION_SERVICE_VERSION_PATCH}
  SOVERSION ${UBUNTU_LOCATION_SERVICE_VERSION_MAJOR}
)

add_definitions(${ENABLED_PROVIDER_TARGETS_DEFINITIONS})

target_link_libraries(
  ubuntu-location-service-connectivity

  ${CMAKE_THREAD_LIBS_INIT}
  ${Boost_LIBRARIES}
  ${DBUS_LIBRARIES}
  ${DBUS_CPP_LDFLAGS}
  ${PROCESS_CPP_LDFLAGS}
  ${GLog_LIBRARY}
  ${GFlags_LIBRARY}
)

target_link_libraries(
  ubuntu-location-service

  ubuntu-location-service-connectivity

  ${ENABLED_PROVIDER_TARGETS}

  ${CMAKE_THREAD_LIBS_INIT}
  ${Boost_LIBRARIES}
  ${DBUS_LIBRARIES}
  ${DBUS_CPP_LDFLAGS}
  ${JSON_C_LDFLAGS}
  ${LIBAPPARMOR_LDFLAGS}
  ${NET_CPP_LDFLAGS}
  ${TRUST_STORE_LDFLAGS}
  ${UBUNTU_PLATFORM_HARDWARE_API_LDFLAGS}
  ${GLog_LIBRARY}
  ${GFlags_LIBRARY}
)

install(
  TARGETS ubuntu-location-service
  DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(
  TARGETS ubuntu-location-service-connectivity
  DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

add_library(
  ubuntu-location-service-provider-daemon

  service/provider_daemon.cpp
)

add_library(
  ubuntu-location-service-daemon

  service/daemon.cpp
)

add_executable(
  ubuntu-location-service-providerd

  service/provider_daemon_main.cpp
)

add_executable(
  ubuntu-location-serviced

  service/daemon_main.cpp
)

add_executable(
  ubuntu-location-serviced-cli

  service/daemon_cli_main.cpp
)

target_link_libraries(
  ubuntu-location-service-provider-daemon

  ubuntu-location-service
)

target_link_libraries(
  ubuntu-location-service-daemon

  ubuntu-location-service
)

target_link_libraries(
  ubuntu-location-service-providerd

  ubuntu-location-service-provider-daemon

  ${ENABLED_PROVIDER_TARGETS}

  ${Boost_LIBRARIES}
  ${DBUS_LIBRARIES}
  ${DBUS_CPP_LIBRARIES}
  ${GLog_LIBRARY}
  ${GFlags_LIBRARY}
)

target_link_libraries(
  ubuntu-location-serviced

  ubuntu-location-service-daemon

  ${ENABLED_PROVIDER_TARGETS}

  ${Boost_LIBRARIES}
  ${DBUS_LIBRARIES}
  ${DBUS_CPP_LIBRARIES}
  ${GLog_LIBRARY}
  ${GFlags_LIBRARY}
)

target_link_libraries(
  ubuntu-location-serviced-cli

  ubuntu-location-service-daemon

  ${ENABLED_PROVIDER_TARGETS}

  ${Boost_LIBRARIES}
  ${DBUS_LIBRARIES}
  ${DBUS_CPP_LIBRARIES}
  ${GLog_LIBRARY}
  ${GFlags_LIBRARY}
)

install(
  TARGETS ubuntu-location-service-providerd
  DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(
  TARGETS ubuntu-location-serviced
  DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(
  TARGETS ubuntu-location-serviced-cli
  DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== src/location_service/com/ubuntu/location/providers/dummy/CMakeLists.txt ===
add_library(
  dummy
  
  provider.h
  provider.cpp
  delayed_provider.h
  delayed_provider.cpp)

set(
  ENABLED_PROVIDER_TARGETS
  ${ENABLED_PROVIDER_TARGETS} dummy
  PARENT_SCOPE)

=== src/location_service/com/ubuntu/location/providers/geoclue/CMakeLists.txt ===
option(
    LOCATION_SERVICE_ENABLE_GEOCLUE_PROVIDER
    "Enable location provider connecting to existing geoclue providers"
    ON
)

if (LOCATION_SERVICE_ENABLE_GEOCLUE_PROVIDER)

  message(STATUS "Enabling support for Geoclue location providers")

  add_library(geoclue provider.cpp)

  set(
    ENABLED_PROVIDER_TARGETS
    ${ENABLED_PROVIDER_TARGETS} geoclue
    PARENT_SCOPE
  )

  set(
    ENABLED_PROVIDER_TARGETS_DEFINITIONS
    -DCOM_UBUNTU_LOCATION_SERVICE_PROVIDERS_GEOCLUE ${ENABLED_PROVIDER_TARGETS_DEFINITIONS}
    PARENT_SCOPE
  )
endif (LOCATION_SERVICE_ENABLE_GEOCLUE_PROVIDER)

=== src/location_service/com/ubuntu/location/providers/gps/CMakeLists.txt ===
option(
    LOCATION_SERVICE_ENABLE_GPS_PROVIDER
    "Enable location providers relying on the Android HAL to connect to GPS HW"
    ON
)

if ((LOCATION_SERVICE_ENABLE_GPS_PROVIDER) AND (UBUNTU_PLATFORM_HARDWARE_API_FOUND))
    message(STATUS "Enabling GPS location provider")

    include_directories(${UBUNTU_PLATFORM_HARDWARE_API_INCLUDE_DIRS})

    add_library(
        gps

        gps.conf

        hardware_abstraction_layer.cpp

        android_hardware_abstraction_layer.h
        android_hardware_abstraction_layer.cpp

        sntp_reference_time_source.h
        sntp_reference_time_source.cpp

        sntp_client.h
        sntp_client.cpp

        hardware_abstraction_layer.h
        # hardware_abstraction_layer.cpp

        provider.h
        provider.cpp)

    target_link_libraries(gps ${UBUNTU_PLATFORM_HARDWARE_API_LDFLAGS})
  
    set(
      ENABLED_PROVIDER_TARGETS
      ${ENABLED_PROVIDER_TARGETS} gps
      PARENT_SCOPE)

    set(
      ENABLED_PROVIDER_TARGETS_DEFINITIONS
      -DCOM_UBUNTU_LOCATION_SERVICE_PROVIDERS_GPS ${ENABLED_PROVIDER_TARGETS_DEFINITIONS}
      PARENT_SCOPE
    )

    install(FILES gps.conf DESTINATION /etc/)
endif ()

=== debian/changelog ===
location-service (3.0.0+16.04.20160405-0ubuntu1) xenial; urgency=medium

  * Small fixes around provider loading added: tests/mock_engine.h
  * Use a fusion engine provider to generate higher quality position
    updates added:
    include/location_service/com/ubuntu/location/fusion_provider.h
    include/location_service/com/ubuntu/location/fusion_provider_selecti
    on_policy.h
    include/location_service/com/ubuntu/location/newer_or_more_accurate_
    update_selector.h
    include/location_service/com/ubuntu/location/newer_update_selector.h
    include/location_service/com/ubuntu/location/update_selector.h
    src/location_service/com/ubuntu/location/fusion_provider.cpp
    src/location_service/com/ubuntu/location/fusion_provider_selection_p
    olicy.cpp

 -- Scott Sweeny <ci-train-bot@canonical.com>  Tue, 05 Apr 2016 21:33:22 +0000

## location-service 3.0.0+16.04.20160405-0ubuntu3

=== debian/changelog ===
location-service (3.0.0+16.04.20160405-0ubuntu3) yakkety; urgency=medium

  * Rebuild against libjson-c3.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 28 Apr 2016 00:09:09 +0200

location-service (3.0.0+16.04.20160405-0ubuntu2) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 23 Apr 2016 18:44:24 +0000

=== debian/control ===
# This file is autogenerated. DO NOT EDIT!
#
# Modifications should be made to control.in instead.
# This file is regenerated automatically in the clean target.
#
Source: location-service
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Thomas Voß <thomas.voss@canonical.com>
Build-Depends: cmake,
               curl,
               libdbus-cpp-dev (>= 4.1.0),
               debhelper (>= 9),
               doxygen,
               geoclue-ubuntu-geoip,
               google-mock (>= 1.6.0+svn437),
               graphviz,
               libapparmor-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libdbus-1-dev,
               libdbus-cpp-dev,
               libgoogle-glog-dev,
               libgtest-dev,
               libiw-dev,
               libjson-c-dev,
               libnet-cpp-dev,
               libprocess-cpp-dev,
               libtrust-store-dev,
               libubuntu-platform-hardware-api-headers [!arm64 !ppc64el !powerpc],
               libubuntu-platform-hardware-api-dev [!arm64 !ppc64el !powerpc],
               libproperties-cpp-dev,
               lsb-release,
               trust-store-bin,
Standards-Version: 3.9.4
Homepage: http://launchpad.net/location-service
# If you aren't a member of ~phablet-team but need to upload packaging changes,
# just go ahead.  ~phablet-team will notice and sync up the code again.
Vcs-Bzr: https://code.launchpad.net/~phablet-team/location-service/trunk
Vcs-Browser: http://bazaar.launchpad.net/~phablet-team/location-service/trunk/files

Package: libubuntu-location-service3
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: location service aggregating position/velocity/heading
 updates and exporting them over dbus.
 .
 Contains the shared library needed by client applications.

Package: libubuntu-location-service-dev
Section: libdevel
Architecture: any
Multi-Arch: foreign
Recommends: ubuntu-location-service-doc,
Depends: libubuntu-location-service3 (= ${binary:Version}),
         libdbus-1-dev,
         libdbus-cpp-dev,
         libboost-dev,
         ${misc:Depends},
Suggests: ubuntu-location-service-doc,
Description: location service aggregating position/velocity/heading
 updates and exporting them over dbus.
 .
 Contains header files required to develop clients talking to the ubuntu
 location service.

Package: libubuntu-location-service-dbg
Section: debug
Architecture: any
Multi-Arch: foreign
Depends: libubuntu-location-service3 (= ${binary:Version}),
         ${misc:Depends},
Description: location service aggregating position/velocity/heading
 updates and exporting them over dbus.
 .
 Contains debug symbols.

Package: ubuntu-location-service-tests
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: location service aggregating position/velocity/heading
 updates and exporting them over dbus.
 .
 Contains all test executables

Package: ubuntu-location-service-bin
Architecture: any
Depends: libubuntu-location-service3 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         trust-store-bin,
Breaks: ubuntu-location-service-examples (<< 0.0.2),
Replaces: ubuntu-location-service-examples (<< 0.0.2),
Description: location service aggregating position/velocity/heading
 updates and exporting them over dbus.
 .
 Contains the service executable and man pages.

Package: ubuntu-location-service-examples
Architecture: any
Multi-Arch: same
Depends: libubuntu-location-service3 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         ubuntu-location-service-doc,
Description: location service aggregating position/velocity/heading
 updates and exporting them over dbus.
 .
 Contains example service and client.

Package: ubuntu-location-service-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
Recommends: ubuntu-location-service-examples,
Description: location service aggregating position/velocity/heading
 updates and exporting them over dbus.
 .
 Contains documentation for service and client.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

include /usr/share/dpkg/default.mk

distro=$(shell lsb_release -c -s)

ifeq ($(distro),vivid)
	full_version=$(shell cat $(CURDIR)/debian/VERSION.vivid)
else
	full_version=$(shell cat $(CURDIR)/debian/VERSION)
endif

major=$(shell echo $(full_version) | cut -d'.' -f1)
minor=$(shell echo $(full_version) | cut -d'.' -f2)
patch=$(shell echo $(full_version) | cut -d'.' -f3)

ifneq (,$(filter $(DEB_HOST_ARCH),ppc64el powerpc arm64))
        LOCATION_SERVICE_ENABLE_GPS_PROVIDER = OFF
else
        LOCATION_SERVICE_ENABLE_GPS_PROVIDER = ON
endif

%:
	dh $@ --parallel --fail-missing

override_dh_install:
	dh_install -Xubuntu-location-service.1 --fail-missing

override_dh_strip:
	dh_strip --dbg-package=libubuntu-location-service-dbg

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_LIBEXECDIR=/usr/lib/$(DEB_HOST_MULTIARCH)/ubuntu-location-service -DCMAKE_C_COMPILER=$(CC) -DCMAKE_CXX_COMPILER=$(CXX) -DLOCATION_SERVICE_ENABLE_GPS_PROVIDER=$(LOCATION_SERVICE_ENABLE_GPS_PROVIDER) -DUBUNTU_LOCATION_SERVICE_VERSION_MAJOR=$(major) -DUBUNTU_LOCATION_SERVICE_VERSION_MINOR=$(minor) -DUBUNTU_LOCATION_SERVICE_VERSION_PATCH=$(patch)

override_dh_auto_clean:
	rm -f $(CURDIR)/debian/libubuntu-location-service$(major).install.amd64
	rm -f $(CURDIR)/debian/libubuntu-location-service$(major).install.armhf
	rm -f $(CURDIR)/debian/libubuntu-location-service$(major).install.i386
	/bin/sh $(CURDIR)/debian/gen-debian-files.sh $(CURDIR)/debian
	dh_auto_clean

## location-service 3.0.0+16.04.20160405-0ubuntu4

=== debian/changelog ===
location-service (3.0.0+16.04.20160405-0ubuntu4) yakkety; urgency=medium

  * Add missing include to random, making the build fail because
    of undefined default_random_engine

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 28 Apr 2016 10:23:05 +0200

## location-service 3.0.0+16.10.20160524.3-0ubuntu1

=== debian/changelog ===
location-service (3.0.0+16.10.20160524.3-0ubuntu1) yakkety; urgency=medium

  [ CI Train Bot ]
  * Resync trunk.

  [ Thomas Voß ]
  * Fix #1584860. The NM update altered the type of LastSeen to int32.
    (LP: #1584860)

 -- Thomas Voß <ci-train-bot@canonical.com>  Tue, 24 May 2016 09:45:00 +0000

## location-service 3.0.0+16.10.20160613.1-0ubuntu1

=== tests/CMakeLists.txt ===
find_package(Threads)

add_definitions(-DCORE_DBUS_ENABLE_GOOGLE_TEST_FIXTURE -DBOOST_ASIO_DISABLE_MOVE)

option(
    LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER 
    "Rely on dbus test runner to start a private session for testing purposes" 
    ON
)

if (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
    find_program(DBUS_TEST_RUNNER_EXECUTABLE dbus-test-runner)
    message(STATUS "Executing test suite under dbus-test-runner")
endif (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)

# Build mongoose as static library to leverage in location reporter testing
add_library(mongoose mongoose.c)
# Explicitly select c99 when compiling mongoose
set_target_properties(
    mongoose
    PROPERTIES COMPILE_FLAGS "-std=c99")

# Build with system gmock and embedded gtest
set (GMOCK_INCLUDE_DIR "/usr/include/gmock/include" CACHE PATH "gmock source include directory")
set (GMOCK_SOURCE_DIR "/usr/src/gmock" CACHE PATH "gmock source directory")
set (GTEST_INCLUDE_DIR "${GMOCK_SOURCE_DIR}/gtest/include" CACHE PATH "gtest source include directory")

add_subdirectory(${GMOCK_SOURCE_DIR} "${CMAKE_CURRENT_BINARY_DIR}/gmock")

macro(LOCATION_SERVICE_ADD_TEST test_name src)
  add_executable(
    ${test_name}
    ${src})

  target_link_libraries(
    ${test_name}

    ubuntu-location-service
    ubuntu-location-service-connectivity
    ubuntu-location-service-provider-daemon
    ubuntu-location-service-daemon

    mongoose

    ${Boost_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}

    ${PROCESS_CPP_LIBRARIES}

    ${ARGN}

    gmock

    gtest
    gtest_main)

  add_test(${test_name} ${CMAKE_CURRENT_BINARY_DIR}/${test_name} --gtest_filter=*-*requires*)

  # Address android's limit on cmdline length and distill ubuntu-location-service into uls
  install(
    TARGETS ${test_name}
    DESTINATION ${CMAKE_INSTALL_BINDIR}/uls-tests
  )
endmacro(LOCATION_SERVICE_ADD_TEST)

include_directories (
  ${CMAKE_SOURCE_DIR}/src/location_service

  ${GMOCK_INCLUDE_DIR}
  ${GTEST_INCLUDE_DIR}
)

LOCATION_SERVICE_ADD_TEST(acceptance_tests acceptance_tests.cpp)
LOCATION_SERVICE_ADD_TEST(boost_ptree_settings_test boost_ptree_settings_test.cpp)
LOCATION_SERVICE_ADD_TEST(connectivity_manager_test connectivity_manager_test.cpp)
LOCATION_SERVICE_ADD_TEST(controller_test controller_test.cpp)
LOCATION_SERVICE_ADD_TEST(criteria_test criteria_test.cpp)
LOCATION_SERVICE_ADD_TEST(daemon_and_cli_tests daemon_and_cli_tests.cpp)
LOCATION_SERVICE_ADD_TEST(default_permission_manager_test default_permission_manager_test.cpp)
LOCATION_SERVICE_ADD_TEST(engine_test engine_test.cpp)
LOCATION_SERVICE_ADD_TEST(harvester_test harvester_test.cpp)
LOCATION_SERVICE_ADD_TEST(demultiplexing_reporter_test demultiplexing_reporter_test.cpp)
LOCATION_SERVICE_ADD_TEST(time_based_update_policy_test time_based_update_policy_test.cpp)

if (NET_CPP_FOUND)
  LOCATION_SERVICE_ADD_TEST(ichnaea_reporter_test ichnaea_reporter_test.cpp)
endif()

LOCATION_SERVICE_ADD_TEST(position_test position_test.cpp)
LOCATION_SERVICE_ADD_TEST(provider_selection_policy_test provider_selection_policy_test.cpp)
LOCATION_SERVICE_ADD_TEST(provider_factory_test provider_factory_test.cpp)
LOCATION_SERVICE_ADD_TEST(provider_test provider_test.cpp)
LOCATION_SERVICE_ADD_TEST(wgs84_test wgs84_test.cpp)
LOCATION_SERVICE_ADD_TEST(trust_store_permission_manager_test trust_store_permission_manager_test.cpp)
LOCATION_SERVICE_ADD_TEST(runtime_test runtime_test.cpp)
LOCATION_SERVICE_ADD_TEST(state_tracking_provider_test state_tracking_provider_test.cpp)

# Provider-specific test-cases go here.
if (LOCATION_SERVICE_ENABLE_GPS_PROVIDER)
  include_directories(${CMAKE_SOURCE_DIR}/src/location_service)
  LOCATION_SERVICE_ADD_TEST(gps_provider_test gps_provider_test.cpp)
  LOCATION_SERVICE_ADD_TEST(sntp_client_test sntp_client_test.cpp)
endif(LOCATION_SERVICE_ENABLE_GPS_PROVIDER)

if (LOCATION_SERVICE_ENABLE_GEOCLUE_PROVIDERS)
  add_executable(geoclue_provider_test geoclue_provider_test.cpp)
  target_link_libraries(
    geoclue_provider_test
    
    ubuntu-location-service

    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${PROCESS_CPP_LIBRARIES}

    gtest
    gtest_main
  )
  if (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
    add_test(geoclue_provider_test ${DBUS_TEST_RUNNER_EXECUTABLE} --task=${CMAKE_CURRENT_BINARY_DIR}/geoclue_provider_test)
  else (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
    add_test(geoclue_provider_test ${CMAKE_CURRENT_BINARY_DIR}/geoclue_provider_test)
  endif (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
endif (LOCATION_SERVICE_ENABLE_GEOCLUE_PROVIDERS)

LOCATION_SERVICE_ADD_TEST(remote_providerd_test remote_providerd_test.cpp)

LOCATION_SERVICE_ADD_TEST(remote_provider_test remote_provider_test.cpp)
LOCATION_SERVICE_ADD_TEST(espoo_provider_test espoo_provider_test.cpp)
LOCATION_SERVICE_ADD_TEST(delayed_service_test delayed_service_test.cpp)

LOCATION_SERVICE_ADD_TEST(bug_1447110 bug_1447110.cpp)

=== src/location_service/com/ubuntu/location/CMakeLists.txt ===
--- 
+++ 
@@ -35,6 +35,7 @@
   proxy_provider.cpp
   satellite_based_positioning_state.cpp
   settings.cpp
+  state_tracking_provider.h
   time_based_update_policy.cpp
   set_name_for_thread.cpp
   time_since_boot.cpp
@@ -50,6 +51,7 @@
   service/runtime.cpp
   service/runtime_tests.h
   service/runtime_tests.cpp
+  service/state.cpp
   service/trust_store_permission_manager.cpp
 
   service/implementation.cpp

=== src/location_service/com/ubuntu/location/providers/CMakeLists.txt ===
add_subdirectory(dummy)
add_subdirectory(remote)
add_subdirectory(geoclue)
add_subdirectory(gps)
add_subdirectory(skyhook)

set(
  ENABLED_PROVIDER_TARGETS
  ${ENABLED_PROVIDER_TARGETS}
  PARENT_SCOPE
)

set(
  ENABLED_PROVIDER_TARGETS_DEFINITIONS
  ${ENABLED_PROVIDER_TARGETS_DEFINITIONS}
  PARENT_SCOPE
)

=== debian/changelog ===
location-service (3.0.0+16.10.20160613.1-0ubuntu1) yakkety; urgency=medium

  [ Thomas Voß ]
  * Expose service::State to the bus. (LP: #1536774)

 -- marcus.tomlinson@canonical.com <marcus.tomlinson@canonical.com>  Mon, 13 Jun 2016 13:38:47 +0000

## location-service 3.0.0+16.10.20160616-0ubuntu1

=== debian/changelog ===
location-service (3.0.0+16.10.20160616-0ubuntu1) yakkety; urgency=medium

  [ Scott Sweeny ]
  * Fusion provider: Always use an update that came from the same source
    as the previous used update (fixes LP: #1570878) (LP: #1570878)

 -- Thomas Voß <thomas.voss@canonical.com>  Thu, 16 Jun 2016 06:03:16 +0000

## location-service 3.0.0+16.10.20160710-0ubuntu1

=== debian/changelog ===
location-service (3.0.0+16.10.20160710-0ubuntu1) yakkety; urgency=medium

  * Reload trust-stored, when use switched locale in welcome wizard.

 -- Rex Tsai <rex.tsai@canonical.com>  Sun, 10 Jul 2016 21:30:34 +0000

## location-service 3.0.0+16.10.20160912-0ubuntu1

=== CMakeLists.txt ===
--- 
+++ 
@@ -94,6 +94,10 @@
   add_custom_target(formatcode ${CLANG_FORMAT_COMMAND} -i ${UBUNTU_LOCATION_SERVICE_INTERFACE_HEADER_FILES} ${UBUNTU_LOCATION_SERVICE_IMPLEMENTATION_FILES} SOURCES _clang-format)
 endif()
 
+if (DEFINED SNAPPY_UBUNTU_CORE)
+    add_definitions(-DSNAPPY_UBUNTU_CORE)
+endif()
+
 include_directories(
   3rd-party/

=== src/location_service/com/ubuntu/location/CMakeLists.txt ===
--- 
+++ 
@@ -52,6 +52,7 @@
   service/runtime_tests.h
   service/runtime_tests.cpp
   service/state.cpp
+  service/system_configuration.cpp
   service/trust_store_permission_manager.cpp
 
   service/implementation.cpp

=== debian/changelog ===
location-service (3.0.0+16.10.20160912-0ubuntu1) yakkety; urgency=medium

  [ Scott Sweeny, You-Sheng Yang ]
  * Enable gps provider on arm64.

 -- Scott Sweeny <scott.sweeny@canonical.com>  Mon, 12 Sep 2016 20:54:10 +0000

location-service (3.0.0+16.10.20160811-0ubuntu1) yakkety; urgency=medium

  [ Alberto Mardegan ]
  * Don't sent last known position to new sessions (LP: #1604446)

  [ Scott Sweeny ]
  * Enable running location-service on Snappy Ubuntu Core

  [ Thomas Voß ]
  * Make sure that we are not racing with the timeout handler.

 -- Thomas Voß <thomas.voss@canonical.com>  Thu, 11 Aug 2016 08:27:10 +0000

=== debian/control ===
--- 
+++ 
@@ -29,8 +29,8 @@
                libnet-cpp-dev,
                libprocess-cpp-dev,
                libtrust-store-dev,
-               libubuntu-platform-hardware-api-headers [!arm64 !ppc64el !powerpc],
-               libubuntu-platform-hardware-api-dev [!arm64 !ppc64el !powerpc],
+               libubuntu-platform-hardware-api-headers [!ppc64el !powerpc],
+               libubuntu-platform-hardware-api-dev [!ppc64el !powerpc],
                libproperties-cpp-dev,
                lsb-release,
                trust-store-bin,

=== debian/rules ===
--- 
+++ 
@@ -27,7 +27,7 @@
 minor=$(shell echo $(full_version) | cut -d'.' -f2)
 patch=$(shell echo $(full_version) | cut -d'.' -f3)
 
-ifneq (,$(filter $(DEB_HOST_ARCH),ppc64el powerpc arm64))
+ifneq (,$(filter $(DEB_HOST_ARCH),ppc64el powerpc))
         LOCATION_SERVICE_ENABLE_GPS_PROVIDER = OFF
 else
         LOCATION_SERVICE_ENABLE_GPS_PROVIDER = ON
@@ -46,8 +46,5 @@
 	dh_auto_configure -- -DCMAKE_INSTALL_LIBEXECDIR=/usr/lib/$(DEB_HOST_MULTIARCH)/ubuntu-location-service -DCMAKE_C_COMPILER=$(CC) -DCMAKE_CXX_COMPILER=$(CXX) -DLOCATION_SERVICE_ENABLE_GPS_PROVIDER=$(LOCATION_SERVICE_ENABLE_GPS_PROVIDER) -DUBUNTU_LOCATION_SERVICE_VERSION_MAJOR=$(major) -DUBUNTU_LOCATION_SERVICE_VERSION_MINOR=$(minor) -DUBUNTU_LOCATION_SERVICE_VERSION_PATCH=$(patch)
 
 override_dh_auto_clean:
-	rm -f $(CURDIR)/debian/libubuntu-location-service$(major).install.amd64
-	rm -f $(CURDIR)/debian/libubuntu-location-service$(major).install.armhf
-	rm -f $(CURDIR)/debian/libubuntu-location-service$(major).install.i386
-	/bin/sh $(CURDIR)/debian/gen-debian-files.sh $(CURDIR)/debian
+	/bin/sh $(CURDIR)/debian/bileto_pre_release_hook
 	dh_auto_clean
